Telegram for Ubuntu

Pre-requisites
==============
These instructions have been tested on:

    1. Ubuntu 14.04 (Trusty Tahr)
    2. Ubuntu 14.10 (Utopic Unicorn)

Ensure you have the Ubuntu SDK installed, as per:
    http://developer.ubuntu.com/start/ubuntu-sdk/installing-the-sdk/

You must set two environment variables for all scripts to work properly:

    CLICK_SDK_ARCH=armhf                    # a value of amd64 also supported
    CLICK_SDK_FRAMEWORK=ubuntu-sdk-14.10


Bootstrap your development environment
======================================

    ./bootstrap.sh

This step will call ``click chroot create`` to create the standard Ubuntu
click chroot build environment. It will also install the required build
dependencies for Telegram into the click chroot.

If you already have the chroot and prerequisite packages installed, then
calling ``./bootstrap.sh`` will only fetch the latest library files.

Once in a while, it is better to run ``./bootstrap.sh update`` to upgrade
the chroot and ensure it is up to date.


Building
========

    ./build.sh

This step will cross-compile Telegram in the click chroot. After running this
step, you may also open the project in the Ubuntu IDE, by selecting the
CMakeLists.txt file in the top-level directory.


Packaging
=========

    ./click.sh

This step will create an armhf click package suitable for installation on
an Ubuntu Phone/Tablet device. To install the package for testing:

    ./click.sh install

Afterwards, search for the "telegram" in the App scope, and tap the icon
to launch the app.


Running on Ubuntu desktop
=========================
Alternatively, it is possible to build and run on your existing Ubuntu
workstation (desktop or laptop).

NOTE: this technique only works for Ubuntu 14.10 (utopic unicorn) machines
      using the amd64 architecture.

To run in this mode, you must:

    1. set CLICK_SDK_ARCH=amd64
    2. ./bootstrap.sh               # creates a separate amd64 click chroot
    3. ./build.sh                   # build for amd64 architecture
    4. ./run.sh                     # runs app on desktop

NOTE: you also need to install qml-module-qt-labs-settings on your host.

NOTE: running on an Ubuntu 14.04 LTS (trusty) machine is possible using
      LXC, but that is an advanced technique, and out of scope for this
      document. If you are truly interested, please try the ``create``
      script from the following repo:

      https://github.com/achiang/ubuntu-sdk-lxc


Debugging
=========
Telegram will log debug output on the phone to:

    /home/phablet/.cache/upstart/

The file name will resemble:

    application-click-com.ubuntu.telegram_telegram_0.2.0+2.log

But will change depending on the version number. Another common error may
be AppArmor denials. To view those:

    grep DENIED /var/log/syslog | grep telegram

If Telegram crashes, it will create crash files similar to:

    /var/crash/_usr_lib_arm-linux-gnueabihf_qt5_bin_qmlscene.32011.crash

If there are also files named *.upload and *.uploaded, it means that the
Ubuntu system error logger (named ``whoopsie``) has uploaded them to

    https://errors.ubuntu.com/

You must login to the page using your Ubuntu SSO credentials. Then you can
find your crash's stack trace by navigating to:

    https://errors.ubuntu.com/oops/<OOPS-ID>

To find the OOP-ID, view:

    /var/crash/upstart/whoopsie.log

And search for a line that resembles:

    Reported OOPS ID 4923130e-1879-11e4-ab04-fa163e339c81

The long hex string should be entered into the URL above (without the angle
brackets).

If whoopsie did not upload the crash to the Ubuntu error tracker, you can
still analyze the crash locally. Use ``adb pull`` to copy the *.crash file
onto your development machine. Then:

    sudo apt-get install apport-retrace
    apport-cli <name of crash file>

You can then follow the menu options to 'V'iew the trace locally. The other
option is to install ``apport-retrace`` on your device itself, and directly
issue:

    apport-retrace <name of crash file>

Finally, please file all bugs to:

    https://bugs.launchpad.net/libqtelegram


Development
===========

These are the important branches:

    lp:libqtelegram

 - the trunk of the libqtelegram library

    lp:libqtelegram/dev

 - the devel branch of the libqtelegram library

    lp:libqtelegram/app

 - the trunk of the Telegram app

    lp:libqtelegram/app-dev

 - the devel branch of the Telegram app

Propose Telegram application merges to this branch:

    lp:libqtelegram/app-dev

Propose libqtelegram library merges to this branch:

    lp:libqtelegram/dev


More or less on the weekly basis, we land the devel branches to trunks.

bzr tagging of lp:libqtelegram/app:
Once a new page of the app is feature ready, bump the MINOR version.
For backward compatible bug fixes, bump the PATCH version.

    bzr tag MAJOR.MINOR.PATCH

Building in the IDE is not fully supported, but you can try.

    * be sure to import CMakeLists.txt
    * add -DCLICK_MODE=on as a cmake command line arg


Credits
=======
Telegram for Ubuntu uses libqtelegram, a Telegram library written in Qt,
based on telegram-cli @ https://github.com/vysheng/tg


Contact
=======
rmescandon and karni @ irc.freenode.net

