#!/usr/bin/env python3

import csv
import simplejson as json
import operator

def dump_json():
    name_to_tel = {}
    name_to_iso = {}
    iso_to_name = {}
    iso_to_tel  = {}
    tel_to_name = {}
    tel_to_iso  = {}

    with open('assets/countries.csv', encoding="utf-8") as f:
        reader = csv.reader(f, delimiter=';')
        for row in reader:
            name = row[2]
            iso = row[1] # two letter country code
            tel = row[0]

            if not tel or not iso:
                continue

            name_to_tel[name] = tel
            name_to_iso[name] = iso
            iso_to_name[iso] = name
            iso_to_tel[iso] = tel
            tel_to_name[tel] = name
            tel_to_iso[tel] = iso

    with open('js/country_data.js', 'w', encoding='utf-8') as f:
        f.write("var name_to_tel = ")
        f.write(json.dumps(name_to_tel))
        f.write(";\n")
        f.write("var name_to_iso = ")
        f.write(json.dumps(name_to_iso))
        f.write(";\n")
        f.write("var iso_to_name = ")
        f.write(json.dumps(iso_to_name))
        f.write(";\n")
        f.write("var iso_to_tel = ")
        f.write(json.dumps(iso_to_tel))
        f.write(";\n")
        f.write("var tel_to_name = ")
        f.write(json.dumps(tel_to_name))
        f.write(";\n")
        f.write("var tel_to_iso = ")
        f.write(json.dumps(tel_to_iso))

if __name__ == "__main__":
    dump_json()
