.pragma library

var MILLIS_IN_DAY = 1000 * 60 * 60 * 24;
var MILLIS_IN_WEEK = 7 * MILLIS_IN_DAY;

function format(time) {
    var date = new Date(time);
    var today = new Date();

    var isToday = date.getDate() === today.getDate();
    if (isToday) {
        return Qt.formatTime(date, "hh:mm");
    } else {
        var oneWeekAgo = new Date(today.getTime() - MILLIS_IN_WEEK);
        var isLessThanWeek =
                date.getTime() > oneWeekAgo.getTime() &&
                date.getDate() !== oneWeekAgo.getDate();
        if (isLessThanWeek) {
            return Qt.formatDate(date, "ddd");
        }
    }
    return Qt.formatDate(date, "MMM d");
}

function formatSection(time) {
    var date = new Date(time);

    return Qt.formatDate(date, "MMMM d");
}

function formatLastSeen(time) {
    var date = new Date(time);
    var today = new Date();
    var yesterday = new Date(today - MILLIS_IN_DAY);

    var isToday = date.getDate() === today.getDate();
    if (isToday) {
        return "today at " + Qt.formatTime(date, "hh:mm");
    } else if (date.getDate() === yesterday.getDate()) {
        return "yesterday at " + Qt.formatTime(date, "hh:mm");
    } else {
        return Qt.formatDate(date, "MMM d") + " at " + Qt.formatTime(date, "hh:mm");
    }
}

function formatTimeOnly(time) {
    var date = new Date(time);

    return Qt.formatTime(date, "hh:mm");
}

function areSameDay(date1, date2) {
    var firstDate = new Date(date1)
    var secondDate = new Date(date2)
    if (!firstDate || !secondDate)
        return false
    return firstDate.getFullYear() == secondDate.getFullYear()
            && firstDate.getMonth() == secondDate.getMonth()
            && firstDate.getDate() == secondDate.getDate()
}
