#!/bin/bash

# Hardcode $ARCH for now, as it doesn't make sense to try and run on an
# armhf desktop... If we ever need to support that case, we'll use the
# same environment variable detection trick as bootstrap.sh or build.sh
ARCH=amd64

LIBDIR="build/$ARCH/library/qmlplugin"
if [ ! -d "$LIBDIR" ]; then
    echo "Library not present. Did you bootstrap your environment properly?"
    exit -1
fi

# TODO: it would be nicer to make lxc detection seamless, but for now,
# use a cmdline arg.
if [ "$1" == "lxc" ]; then
    # XXX: change if your container has a different name
    CONTAINER=ubuntu-sdk

    if ! lxc-wait -n $CONTAINER -s RUNNING -t 0; then
        lxc-start -n $CONTAINER -d
        lxc-wait -n $CONTAINER -s RUNNING
    fi

    user=$(logname)
    wd=`pwd | sed "s/$user/ubuntu/"`

    lxc-attach --clear-env -n $CONTAINER -- sudo -u ubuntu -i \
        env DISPLAY=$DISPLAY QML2_IMPORT_PATH=$LIBDIR \
        QT_LOGGING_RULES="tg.net.*.debug=false" \
        LD_LIBRARY_PATH=$LD_LIBRARY_PATH:"$wd/build/$ARCH/library/lib" \
        bash -c "cd $wd && qmlscene telegram.qml"

    lxc-stop -n $CONTAINER -t 10
else
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:`pwd`/build/$ARCH/library/lib \
    QML2_IMPORT_PATH=$LIBDIR \
    QT_LOGGING_RULES="tg.net.*.debug=false" \
    qmlscene telegram.qml
fi
