#ifndef CONFIG_H
#define CONFIG_H
const QString DatabasePath = "/home/phablet/.cache/com.ubuntu.telegram/";
const QString U1DBPath = "/home/phablet/.config/com.ubuntu.telegram/";
const QString DatabaseName = "telegram";
const QString u1dbname="settings.u1db";

enum MessageMediaType {
   typeMessageMediaDocument = 0x2fda2204,
   typeMessageMediaContact = 0x5e7d2f39,
   typeMessageMediaEmpty = 0x3ded6320,
   typeMessageMediaVideo = 0xa2d24290,
   typeMessageMediaUnsupported = 0x29632a36,
   typeMessageMediaAudio = 0xc6b68300,
   typeMessageMediaPhoto = 0xc8c45a2a,
   typeMessageMediaGeo = 0x56e0d474
};

const QString TIMEFORMAT = "h:mm ddd, dd-MM-yy";

//QUERYS
const QString GET_UNREAD_QUERY ="unread=1 AND out=0;";
const QString GET_READ_QUERY ="unread=0 AND out=0;";
const QString GET_ALL ="id LIKE '%';";
const QString MESSAGE_TEXT ="text";
const QString MESSAGE_Phone ="fromPhone";
const QString MESSAGE_Thumbnail ="fromThumbnail";
const QString MESSAGE_firstName="fromFirstName";
const QString MESSAGE_lastName="fromLastName";
const QString MESSAGE_unread="unread";
const QString MESSAGE_date="date";
const QString MESSAGE_out="out";
const QString MESSAGE_mediatype="mediaType";
const QString MESSAGE_mediaid="mediaId";
const QString MESSAGE_fromid="fromId";
const QString MESSAGE_PHOTO ="photoSmall";
const QString MESSAGE_VIDEO ="video";
const QString MESSAGE_ISCHAT ="toIsChat";
const QString MESSAGE_TOID ="toId";
const QString MESSAGE_PHOTOLOCAL="photoBigLocal";
const QString DIALOG_UNREAD="unreadCount";
const QString ID_="id";
const QString DIALOG_ISCHAT="isChat";
const QString GET_FROM_MSG_QUERY ="fromId=%1 AND toIsChat=0 ORDER BY " +MESSAGE_date+ " DESC LIMIT %2 ;";
const QString GET_TO_MSG_QUERY ="toId=%1 AND out=0 ORDER BY " +MESSAGE_date+ " DESC LIMIT %2 ;";
const QString GET_ALL_MSG ="id LIKE '%' ORDER BY " +MESSAGE_date+ " DESC;";
const QString U1DB_content="content";

const QString DIALOGS_QUERY =
        "  SELECT *\n"
        "  FROM dialogs\n"
        "  WHERE %1\n";

const QString U1DB_SETTINGS =
        "  SELECT content\n"
        "  FROM document\n"
        "  WHERE doc_id='appSettings';";


const QString MSG_QUERY =
        "   SELECT\n"
        "       id,\n"
        "       fromId,\n"
        "       toId,\n"
        "       "+MESSAGE_ISCHAT+",\n"
        "       "+MESSAGE_out+",\n"
        "       sent,\n"
        "       "+MESSAGE_unread+",\n"
        "       "+MESSAGE_out+",\n"
        "       "+MESSAGE_TEXT +",\n"
        "       "+MESSAGE_mediatype+",\n"
        "       "+MESSAGE_date+",\n"
        "       mediaId\n,"
        "       (SELECT firstName FROM users WHERE id=fromId) AS "+MESSAGE_firstName+",\n"
        "       (SELECT lastName FROM users WHERE id=fromId) AS "+MESSAGE_lastName+",\n"
        "       (SELECT phone FROM users WHERE id=fromId) AS "+ MESSAGE_Phone + ",\n"
        "       (SELECT localPath FROM fileLocations WHERE rowid IN (SELECT thumbnail FROM users WHERE id=fromId)) AS "+ MESSAGE_Thumbnail +",\n"
        "       (SELECT type FROM users WHERE id=fromId) AS fromUserType,\n"
        "       (SELECT localPath FROM fileLocations, photoSizes WHERE fileLocations.rowid=fileLocationId AND "
                    "photoId=mediaId AND (type='s' OR type='m') ORDER BY size DESC LIMIT 1) AS photoSmall,\n"
        "       (SELECT localPath FROM fileLocations, photoSizes WHERE fileLocations.rowid=fileLocationId AND "
                    "photoId=mediaId AND type='local' ORDER BY size DESC LIMIT 1) AS photoBigLocal,\n"
        "       (SELECT localPath FROM fileLocations, photoSizes WHERE fileLocations.rowid=fileLocationId AND "
                    "photoId=mediaId ORDER BY size DESC LIMIT 1) AS photoBigRemote,\n"
        "       (SELECT localPath FROM mediaVideos WHERE id=mediaId) AS video,\n"
        "       (SELECT type FROM messageActions WHERE messageId=id) AS actionType,\n"
        "       (SELECT title FROM messageActions WHERE messageId=id) AS actionTitle\n"
        "   FROM messages\n"
        "   WHERE %1\n";


const QString DATE_FORMAT="dd MMM yyyy";
const QString DISPLAY_DATE_FORMAT="dddd, dd MMMM yyyy";

#endif
