#ifndef DEMOQUERY_H
#define DEMOQUERY_H

#include <unity/scopes/SearchQueryBase.h>
#include <unity/scopes/ReplyProxyFwd.h>
#include <unity/scopes/CategorisedResult.h>
#include <QtSql>
#include <QSqlDatabase>
#include <QFileInfo>
#include <QDir>
#include <QSqlQuery>
#include "config.h"
#include "i18n.h"


struct TelegramContact{
    QString phone;
    QString firstName;
    QString lastName;
    QString thumbNail;
    int id;
};

struct TelegramMessage{
    QString text;
    qint64 date;
    unsigned int mediaType;
    QString mediaId;
    QString groupChatId;
    QString videoThumbnail;
    TelegramContact from;
    bool unread;
    bool out;
    bool groupChat;
    int id;
    QString mediaUrl;
};

class TelegramQuery : public unity::scopes::SearchQueryBase
{
public:
    TelegramQuery(unity::scopes::CannedQuery const& query, unity::scopes::SearchMetadata const& metadata, QString const& scopeDir);
    ~TelegramQuery();
    virtual void cancelled() override;
    virtual void run(unity::scopes::SearchReplyProxy const& reply) override;

private:
    void getOurId(QString phoneNumber);

    QString mScopeDir;
    QSqlDatabase mDb;
    int mOurId;
    std::vector<TelegramMessage> getMessagesFromDB(QString querytext);
    bool openDb();
    unity::scopes::CategorisedResult messageToResult(unity::scopes::Category::SCPtr category, TelegramMessage message,bool useAttachment);
    unity::scopes::CategorisedResult contactToResult(unity::scopes::Category::SCPtr category, TelegramContact contact);
    int getUnreadMessages(std::vector<TelegramMessage> & unreadMessages);
};

#endif

